$ ->
  # create collection popover
  $('#create_collection_popover').popover
    html: true
    content: ->
      $('#create_collection_popover_content').html()
    title: ->
      $('#create_collection_popover_title').html()

  # add learning object to collection
  $(document).on 'click', 'input[class=collection-element]', ->
    url = '/collections/' + encodeURIComponent($(this).data('cid')) + '/learning_object/' + encodeURIComponent($(this).data('loid'))
    if this.checked
      $.ajax {method: "POST", url: url }, (d) ->
        d
    else
      $.ajax {method: "DELETE", url: url }, (d) ->
        d

  # change collection privacy
  $(document).on 'click', 'input[name=privacy]', ->
    url = '/collections/' + encodeURIComponent($(this).data('cid')) + '/change_privacy'
    value = $('input[name=privacy]:checked').val()
    $.post url, {'privacy':value}, (d) ->
      d

  $(document).on 'open_collections_modal', (evt, params) ->
    url = '/collections/' + encodeURIComponent(params) + '/list'
    $.get url, (d) ->
      $('#collections-modal').remove()
      $('body').append d
      $('#collections-modal').modal('show')
      return
  return

# manipulate collections in show page
$ ->
  $(document).on 'ready page:load', ->
    if $('.collection-show-page').val() != undefined
      # array with selected collections ids
      selected_collections = []
      collection = $('.collection-show-page').data('cid')

      # add selectors
      $('.learning-object-vertical').each (e) ->
        loid = $(this).data('loid')
        $('.learning-object-thumbnail', this).append '<input class="collection-selector" type="checkbox" value="' + loid + '"></input>'
        return

      # add/remove collection to array when click checkbox
      $(document).on 'click', '.collection-selector', ->
        if this.checked
          if selected_collections.indexOf(this.value) < 0
            selected_collections.push this.value
            $(document).trigger('check_selected_collection');
          return
        else
          index = selected_collections.indexOf(this.value)
          if !!(~index)
            selected_collections.splice(index, 1)
            $(document).trigger('check_selected_collection');
          return

      # clear selected collections
      $(document).on 'clear_collections', ->
        selected_collections = []
        $('.collection-selector').attr('checked', false);
        $(document).trigger('check_selected_collection')

      $(document).on 'click', '.collection-show-select-nav .navbar-brand', ->
        $(document).trigger('clear_collections')

      # manipulation buttons
      $(document).on 'click', '.collection-button', ->
        switch $(this).data('action')
          when 'download' then
          when 'copy' then $(document).trigger('open_collections_modal', [collection])
          when 'move' then
          when 'remove' then

      # update interface when add/remove a collection
      $(document).on 'check_selected_collection', (e) ->
        length = selected_collections.length
        if length == 0
          return $('.collection-show-select-nav').slideUp('slow')
        else if (length == 1)
          html = "1 objeto selecionado"
        else
          html = length + " objetos selecionados"
        $('.collection-show-select-nav .navbar-brand').html html
        $('.collection-show-select-nav').slideDown('slow')

      $(document).on 'submit', '#collections-modal-form', (evt) ->
        evt.preventDefault()
        url = '/collections/' + encodeURIComponent(collection) + '/copy'
        collections = $(this).serializeArray()
        $.ajax {method: "POST", url: url, data: {col: collections} }, (d) ->
          console.log d
          return
        console.log collections
        $('#collections-modal').modal('close')
        return
      return
