class InstitutionBuilder < Builder
  extend RepositoriesProxy

  ##
  # receive a list of ids and return a list of institutions
  #
  def self.build(institutions = [])
    array = []
    institutions = [institutions] if institutions.class == String
    institutions.each do |institution|
      unless institution['@rid'].blank?
        o = Rails.cache.fetch(cache_key(institution['@rid'], institution['last_modified'])) unless institution['last_modified'].blank?
        o = institution_repository.find institution['@rid'] if o.nil?
        array << o
      end
    end
    array
  end

  def self.build_from_orientdb(args = {})
    institution = nil

    unless args.nil?
      # cache object when build
      institution = Rails.cache.fetch(cache_key(args['@rid'], args['last_modified']), expires_in: 12.hours) do
        Institution.new(
          id: args['@rid'],
          name: args['name'],
          created_at: args['created_at'],
          last_modified: args['last_modified'],
          country: args['country'] || '',
          city: args['city'] || '',
          description: args['description'] || '',
          thumbnail: args['thumbnail'] || '',
          address: args['address'] || ''
        )
      end
    end

    institution
  end

end
