module OrientDb
  class ComplaintRepository < Base
    include OrientDb::Methods::EdgeMethods
    include RepositoriesProxy

    def report(complaint)
      if edge_exists?(odb_class, complaint.user.rid, complaint.object)
        false
      else
        connection.command "CREATE EDGE Complaint FROM #{complaint.user.rid} TO #{complaint.object} SET message = '#{complaint.message}', description = '#{complaint.description}'"
      end
    end

    def destroy(user_rid, object_rid)
      if !edge_exists?(odb_class, user_rid, object_rid)
        raise "The object has not been reported by you yet."
      end

      connection.command "DELETE EDGE Complaint FROM #{user_rid} TO #{object_rid}"
    end

    def build_object(args={})
      Complaint.new(args)
    end

    def get_complaints
      result = connection.command "SELECT FROM Complaint"
      build_complaint result
    end


    def build_complaint(args)
      complaint = Array.new
      for i in 0..args["result"].length-1
        unless args.nil?
          complaint[i] = Complaint.new(:user => args["result"][i]["out"], :object => args["result"][i]["in"], :message => args["result"][i]["message"], :description => args["result"][i]["description"])
        end
      end
      complaint
    end

  end
end
