module OrientDb

  ##abstract class Relation
  class Relation

    def can_create?
      raise NotImplementedError, 'Relation#can_execute? is an abstract method.'
    end

    def create
      execute if can_create?
    end

    protected

    attr_accessor :connection

    def execute
      raise NotImplementedError, 'Relation#execute is an abstract method.'
    end

  end
end