module OrientDb
  class SubjectRepository < Base
    include OrientDb::Methods::EdgeMethods
    include RepositoriesProxy

    def find_by_name(name)
      result = select_by_property(odb_class, "name", name)
      build_object(result.first)
    end

    def destroy(id)
      connection.command "DELETE VERTEX Subject where @rid = '#{id}'"
    end

    def update(id, operation, atributte, new_value)
      connection.command "update #{id} #{operation} #{atributte} = #{new_value}"
    end

    def get_learning_objects(subject)
      result = get_edges_end("IsAbout", "in", subject.id)
      learning_object_repository.build_objects(result)
    end

    def get_subtopics(subject)
      result = get_edges_end("Subtopic", "in", subject.id)
      build_objects(result)
    end

    def get_supertopics(subject)
      result = get_edges_end("Subtopic", "out", subject.id)
      build_objects(result)
    end

    def get_highlights(subject)
      result = connection.query "SELECT expand(highlights) FROM #{subject.id}"
      learning_object_repository.build_objects(result)
    end

    def add_supertopic(subject, supertopic)
      subject.supertopics << supertopic
      unless edge_exists?("Subtopic", subject.id, supertopic.id)
        create_edge("Subtopic", subject.id, supertopic.id)
      end
    end

    def create_relations(subject)
      OrientDb::Subject::RelationsChain.new(subject, connection).create
    end

    def build_hash(object)
      hash = super(object)
      hash.delete("learning_objects")
      hash
    end

    def build_object(args={})
      SubjectBuilder.build_from_orientdb args
    end

  end
end
