module Bitstream
  module AcceptedFormats

    def get_file_basename file
      unless file.nil?
        file_format = File.basename(file)
      else
        file_format = ""
      end
      file_format
    end

    def get_file_extname file
      unless file.nil?
        file_name = File.extname(file)
      else
        file_name = ""
      end
      file_name
    end

    def array_to_upcase array
      upcase_array = []
      array.each do |a|
        upcase_array << a.upcase
      end
      upcase_array
    end

    def accepted_archive_formats
      lower = [".zip", ".gzip", ".bzip", ".tar"]
      upper = array_to_upcase lower
      return lower + upper
    end

    def accepted_video_formats
      lower = [".mp4", ".wmv", ".3gp", ".asf", ".avi", ".flv", ".swf", ".mov", ".mpg", ".mpeg", ".rmvb", ".rm", ".vob", ".webm"]
      upper = array_to_upcase lower
      return lower + upper
    end

    def accepted_image_formats
      lower = [".jpg", ".jpeg", ".gif", ".png", ".bmp", ".tif", ".wmf"]
      upper = array_to_upcase lower
      return lower + upper
    end

    def accepted_other_formats
      lower = [".pdf", ".pps"]
      upper = array_to_upcase lower
      return lower + upper
    end

    def accepted_formats
      return accepted_video_formats + accepted_image_formats + accepted_other_formats
    end

  end
end
